;;; -*- Lisp -*-
;;;
;;; CLM has one package now: clm

(defpackage :clm 
  (:use :common-lisp) 
  #+(or pcl mcl) (:import-from "WALKER" "WALK-FORM")
  #+(and excl cltl2) (:import-from "CLOS" "WALK-FORM")
  #+mcl (:import-from "CCL" "%STACK-BLOCK" "%GET-UNSIGNED-LONG")
  (:export "*CLM*" "*CLM-VERSION*" "*CLM-NEWS*" "*CLM-DATE*" "*CLM-VERBOSE*" "*CLM-ARRAY-PRINT-LENGTH*" "*CLM-INIT*"
	"*CLM-SAFETY*" "*CLM-SPEED*" "*SOUND-PLAYER*" "*GRAB-DAC*" "*CLM-INTERRUPTED*"
	"IO" "IO-P" "MAKE-IO" "IO-BEG" "IO-END" "IO-SIZ" "IO-DATA-END" "IO-DAT-A" "IO-DAT-B" "IO-DAT-C" "IO-DAT-D" "IO-NAM" "IO-DIR" "IO-FIL"
	"IO-OPEN-INDEX" "IO-HDR" "IO-DATA-START" "IO-BUFSIZ" "IO-HDR-END"
	"*CURRENT-OUTPUT-FILE*" "*CURRENT-INPUT-FILE*" "FILE-BUFFER-SIZE" "*CLM-CURRENT-OPEN-FILES*"
	"CLM-OPEN-INPUT" "CLM-OPEN-OUTPUT" "CLM-CLOSE-INPUT" "CLM-CLOSE-OUTPUT" "CLM-REOPEN-OUTPUT"
	"OUTA" "OUTB" "OUTC" "OUTD" "INA" "INB" "IN-A" "IN-B" "IN-C" "IN-D" "QUAD" "STEREO" "MONO"
	"*REVERB*" "REVIN" "REVOUT"
	"*AVAILABLE-IO-CHANNELS*"
	"FULL-MERGE-PATHNAMES"
	"MAKE-HEADER" "READ-HEADER" "WRITE-HEADER" "UPDATE-HEADER" "EDIT-HEADER"
	"DEFAULT-SOUND-FILE-NAME" "DEFAULT-REVERB-FILE-NAME" "DEFAULT-SOUND-FILE-TYPE"
	"SND-HEADER-COMMENT"
	"*IGNORE-HEADER-ERRORS*" "*FIX-HEADER-ERRORS*"
	"AIFF-SOUND-FILE" "NEXT-SOUND-FILE" "RIFF-SOUND-FILE"
	"VOLUME" "DAC-FILTER"
	"ONE-PI" "TWO-PI" "HALF-PI" "THREE-HALF-PI" "SAMPLING-RATE" "FREQUENCY-MAG" "SET-SRATE" "IN-HZ"
	"OSC" "OSC-FREQ" "OSC-PHASE" "MAKE-OSC" "OSC-P" "OSCIL" "MAKE-OSCIL"
	"DEFAULT-TABLE-SIZE" "MAX-AMP" "NORMALIZE" "ARRAY-INTERP" "MAKE-TABLE" "GET-INCREMENT" "TABLE-INTERP"
	"TBL" "MAKE-TBL" "TBL-P" "TBL-FREQ" "TBL-INTERNAL-MAG" "TBL-PHASE" "TBL-TABLE" "TBL-TABLE-SIZE"
	"MAKE-TABLE-LOOKUP" "UR-TABLE-LOOKUP" "TABLE-LOOKUP" "LOAD-SYNTHESIS-TABLE"
	"RING-MODULATE" "AMPLITUDE-MODULATE"
	"DLY" "MAKE-DLY" "DLY-P" "DLY-SIZE" "DLY-PLINE" "DLY-LOC" "DLY-ID" "DLY-EXT-ID" "MAKE-DELAY" "DELAY" "*CLM-DELAY-LINES*" "TAP"
	"ZDLY" "MAKE-ZDLY" "ZDLY-P" "ZDLY-DEL" "ZDLY-PHASE" "MAKE-ZDELAY" "ZDELAY" "REMEMBER-ZDELAY" "*CLM-ZDELAY-LINES*" "ZTAP"
	"CMBFLT" "MAKE-CMBFLT" "CMBFLT-P" "CMBFLT-DLY-UNIT" "CMBFLT-SCALER" "MAKE-COMB" "COMB" "NOTCH" "MAKE-NOTCH"
	"ALLPASSFLT" "MAKE-ALLPASSFLT" "ALLPASSFLT-P" "ALLPASSFLT-DLY-UNIT" "ALLPASSFLT-FEEDFORWARD"
	"ALLPASSFLT-FEEDBACK" "MAKE-ALL-PASS" "ALL-PASS"
	"FLT" "MAKE-FLT" "FLT-P" "FLT-A" "FLT-B" "FLT-C" "FLT-D" "FLT-M" "FLT-SO" "FLT-TYP" "MAKE-FILTER" "FILTER"
	"CONVOLVE" "MAKE-CONVOLVE" "CONV" "CONV-P" "MAKE-CONV" "CONV-FILTR" "CONV-FILTI" "CONV-FFTF"
	"DOT-PRODUCT"
	"SMPFLT" "MAKE-SMPFLT" "SMPFLT-P" "SMPFLT-A0" "SMPFLT-A1" "SMPFLT-A2" "SMPFLT-B1"
	"SMPFLT-B2" "SMPFLT-X1" "SMPFLT-X2" "SMPFLT-Y1" "SMPFLT-Y2"
	"ONE-POLE" "ONE-ZERO" "TWO-POLE" "TWO-ZERO" "MAKE-ONE-POLE" "MAKE-ONE-ZERO" "MAKE-TWO-POLE" "MAKE-TWO-ZERO"
	"MAKE-PPOLAR" "PPOLAR" "MAKE-ZPOLAR" "ZPOLAR"
	"FRMNT" "MAKE-FRMNT" "FRMNT-P" "MAKE-FORMNT" "FORMNT" "FRMNT-G" "FRMNT-TP" "FRMNT-TZ"
	"LATTICE-FILTER" "LADDER-FILTER" "FFT-FILTER" "DIRECT-FILTER"
	"MAKE-LATTICE-FILTER" "MAKE-LADDER-FILTER" "MAKE-DIRECT-FILTER" "DIRECT-FORM" "LATTICE-FORM" "LADDER-FORM" "MAKE-FFT-FILTER"
	"NOI" "MAKE-NOI" "NOI-P" "NOI-FREQ" "NOI-BASE" "NOI-PHASE" "NOI-OUTPUT" "NOI-INCR" "NOI-RAN-OP"
	"MAKE-RANDH" "RANDH" "MAKE-RANDI" "RANDI"
	"ENVELOPE" "MAKE-ENVELOPE" "ENVELOPE-P" "ENVELOPE-CURRENT-VALUE" "ENVELOPE-RATE" "ENVELOPE-DATA" "ENVELOPE-PASS" "ENVELOPE-END"
	"ENVELOPE-BASE" "ENVELOPE-OFFSET" "ENVELOPE-SCALER" "ENVELOPE-POWER" "ENVELOPE-OP" "ENVELOPE-RESTART" "ENVELOPE-TYPE"
	"LIST-INTERP" "MAX-ENVELOPE" "SCALE-ENVELOPE" "NORMALIZE-ENVELOPE" "ENV-LAST-X" "RESTART-ENV"
	"ENV" "MAKE-ENV" "DIVSEG" "DIVENV" "OP-Y-ENV" "OP-X-ENV" "FIX-ENVELOPE" "MAKE-FUNC"
	"SW" "MAKE-SW" "SW-P" "SW-CURRENT-VALUE" "SW-FREQ" "SW-PHASE" "SW-BASE"
	"MAKE-TRIANGLE-WAVE" "TRIANGLE-WAVE" "MAKE-SQUARE-WAVE" "SQUARE-WAVE"
	"MAKE-SAWTOOTH-WAVE" "SAWTOOTH-WAVE" "MAKE-PULSE-TRAIN" "PULSE-TRAIN"
	"WS" "MAKE-WAVESHAPE-TABLE" "MAKE-PHASE-QUAD-TABLE" "MAKE-WAVESHAPE" "WAVESHAPE" "WS-P" "MAKE-WS" "WS-TAB" "WS-OS" "WS-OFFSET"
	"GET-CHEBYCHEV-COEFFICIENTS" "NORMALIZE-PARTIALS" "POLYNOMIAL"
	"LOCSIG" "MAKE-LOCSIG" "LOCS" "LOCS-P" "LOCS-ASCL" "LOCS-BSCL" "LOCS-CSCL" "LOCS-DSCL" "LOCS-RSCL"
	"LOCS-DEG" "LOCS-DIS" "LOCS-PC-REV" "LOCS-REVNAME" "MAKE-LOCS" "MAKE-QUADSIG"
	"MAKE-ROOMSIG" "RMLOC" "RMLOC-P" "RMLOC-W" "RMLOC-L" "RMLOC-UW" "RMLOC-UL" "RMLOC-DATA" "RMLOC-DISTS"
	"SMP" "MAKE-SMP" "SMP-P" "SMP-FIL" "SMP-SR" "SMP-X" "SMP-LST" "SMP-NXT" "SMP-I" "SMP-CHN" "MAKE-RESAMPLE" "RESAMPLE"
	"CONTRAST-ENHANCEMENT" "GET-BEG-END"
	"CLM-GET-DURATION" "CLM-GET-CHANNELS" "CLM-GET-SAMPLING-RATE" "CLM-GET-MAX-AMP" "CLM-GET-SAMPLES"
	"READIN" "MAKE-READIN" "READIN-REVERSE" "MAKE-REVERSE"
	"RDIN-P" "RDIN" "MAKE-RDIN" "RDIN-I" "RDIN-INC" "RDIN-CHN" "RDIN-FIL"
	"SUM-OF-COSINES" "MAKE-SUM-OF-COSINES" "COSP" "COSP-P" "COSP-COSINES" "COSP-PHASE" "COSP-FREQ" "COSP-SCALER" "MAKE-COSP"
	"SINE-SUMMATION" "MAKE-SINE-SUMMATION" "SSS" "SSS-P" "SSS-PHASE" "SSS-FREQ" "SSS-A" "SSS-N" "SSS-B" "MAKE-SSS"
	"ASYMMETRIC-FM" "MAKE-ASYMMETRIC-FM" "ASYMFM" "ASYMFM-P" "ASYMFM-R" "ASYMFM-PHASE" "ASYMFM-FREQ" "ASYMFM-RATIO" "ASYMFM-R" "MAKE-ASYMFM"
	"RBLK-P" "RBLK-BUF" "RBLK-SIZ" "RBLK-CTR" "RBLK-LOC" "MAKE-RBLK" "MAKE-BLOCK" "RUN-BLOCK" "CLEAR-BLOCK" "RBLK"
	"WT" "WT-P" "MAKE-WT" "WT-WAVE" "WT-WSIZ" "WT-FREQ" "WT-B" "MAKE-WAVE-TRAIN" "WAVE-TRAIN" "WT-PHASE" "WT-INTERNAL-MAG"
	"MAKE-EXPAND" "EXPAND"
	"SPD" "SPD-P" "MAKE-SPD" "SPD-RD" "SPD-LEN" "SPD-RMP" "SPD-AMP" "SPD-IN-SPD" "SPD-OUT-SPD" "SPD-TYP" "SPD-CUR-IN" "SPD-CUR-OUT"
	"SPD-B" "SPD-S20" "SPD-S50" "SPD-CTR"
	"MAKE-SRC" "SRC" "MAKE-SR" "SR" "SR-RD" "SR-P" "MAKE-SR" "SR-X" "SR-INCR" "SR-DATA" "SR-WIDTH" "SR-LEFT" "SR-RIGHT" "SINC" "SR-FILT"
	"FFTFLT-P" "MAKE-FFTFLT" "FFTFLT-ENV" "FFTFLT-SIZ" "FFTFLT-HOP" "FFTFLT-RD" "FFTFLT-B"
	"FFTFLT-DATAR" "FFTFLT-DATAI" "FFTFLT-HALF-SIZ" "FFTFLT"
	"FFT" "INVERSE-FFT" "FFT-WINDOW"
	"MAKE-FFT-DATA" "FFT-DATA-P" "FFT-DATA-REAL" "FFT-DATA-IMAGINARY" "FFT-DATA-SIZE" "FFT-DATA" "MAKE-FFT-DATA-ARRAYS"
	"SPECTRUM" "RECTANGULAR-WINDOW" "HANNING-WINDOW" "WELCH-WINDOW" "PARZEN-WINDOW" "BARTLETT-WINDOW"
	"HAMMING-WINDOW" "ORDER-0-WINDOW" "ORDER-1-WINDOW" "ORDER-2-WINDOW" "ORDER-3-WINDOW" "ORDER-4-WINDOW"
	"EXPONENTIAL-WINDOW" "KAISER-WINDOW"
	"READ-FORWARD" "READ-BACKWARD" "READ-POSITION"
	"SHOW-DATA" "SHOW-LOG-DATA" "PRINT-HASH" "CLM-PRINT"
	"LONG-INT" "REAL" "FRACTION" "TABLE"
	"SOUND-ERROR" "DSP-WHO" "START-DAC" "STOP-DAC" "ABORT-DAC" "WAIT-FOR-DAC" "DAC-IS-IN-USE"
	"*CLM-LANGUAGE*" "*CLM-PHRASES-ACTIVE*"
	"CLM-NOTEHOOK" "CLM-STATISTICS" "CLM-LAST-BEGIN-TIME" "CLM-TOTAL-DURATION"
	"CLM-INITIALIZE-STATISTICS" "CLM-PRINT-STATISTICS" "CLM-INITIALIZE-NOTEHOOK"
	"CLM-GET-DEFAULT-HEADER"
	"RUN" "END-RUN"
	"C56-CLEANUP" "C56-RESET-CLEANUP" "C56-DEBUG" "C-DEBUG"
	"DSP-OPEN" "DSP-CLOSE" "DSP-IS-OPEN"
	"SET-INSTRUMENT-PROPERTIES" "*CURRENT-INSTRUMENT-NAME*"
	"DISPLAY-DSP-STATE" "DESCRIBE-DSP-STATE" "DESCRIBE-C-STATE" "DESCRIBE-INS-STATE"
	"DEF-CLM-STRUCT" "USER-STRUCTS"
	"MAKE-PHRASE" "WAIT-FOR-PHRASE" "PHRASE-VALUE" "PHRASE"
	"INSTRUMENT-VALUE" "SET-UP-DSP-MEMORY-MAP"
	"WITH-SOUND" "CLM-LOAD" "DAC" "DAC-N" "CLOSE-OUTPUT" "CLOSE-INPUT" "DEFINSTRUMENT" "DAC*" "DEFCINSTRUMENT"
	"OPEN-OUTPUT" "REOPEN-OUTPUT" "OPEN-INPUT" "CLU-RESET" "INSTRUMENT-LET" "MIX-SOUND" "MIX-IN" "MIX"
	"*OPEN-INPUT-VERBOSE*" "*OPEN-INPUT-PRINT*" "*OPEN-INPUT-TRUENAME*" "*OPEN-INPUT-PATHNAME*" "*CLM-FORCE-RECOMPUTATION*"
	"*OPEN-INPUT-EXPLICIT-OUTPUT*" "*OPEN-INPUT-EXPLICIT-REVERB*" "*MIX-CALLS*" "*SOUND-PLAYER*" "DPYSND"
	"*CLM-INSTRUMENTS*" "SOUND-LET" "WITH-MIX" "*MIX-OPTIONS*" "FASMIX" "COMPILE-INS" "*GRAB-DAC*" "*REVERB-DECAY-TIME*"
	"INIT-WITH-SOUND" "FINISH-WITH-SOUND" "CLM-CLEANUP"

	#+NeXT "JRDAC" #+NeXT "INIT-JRDAC"

	"EREF" "ENV-LENGTH" "ENV-REVERSE" "ENV-CONCATENATE" "ENV+" "ENV*" "ENV-MAX" "ENV-REPEAT"
	"ENV-FUNCALL" "ENV-APPLY" "ENV-MAP" "MAP-ACROSS-ENVELOPES" "ADD-OR-EDIT-BREAKPOINT" "REMOVE-BREAKPOINT"
	"ENV-SIMPLIFY" "FFT-ENV-SIMPLIFY" "REDUCE-AMPLITUDE-QUANTIZATION-NOISE" "MELD-ENVELOPES"

	"ZTAP"

	))
